#include <stdio.h>
#include <stdlib.h>

#define x(index) ((index) % (4))
#define y(index) ((index) / (4))
#define ind(x, y) (((y)*4) + (x))

#define verbose 0

void printData(int data[][4][4]) {
	int i, j;
	for(i = 0; i < 4; i++) {
		for(j = 0; j < 4; j++)
			printf("%d | ", data[0][j][i]);
		printf("\n");
	}
}

int works(int data[][4][4], int sums[][5]) {
	int i, j, sum;
	// Vertical sum
	for(i = 0; i < 4; i++) {
		sum = 0;
		for(j = 0; j < 4; j++) {
			sum += data[0][i][j];
		}
		if(sum != sums[0][i])
			return 0;
	}
	
	// Horizontal sum
	for(i = 0; i < 4; i++) {
		sum = 0;
		for(j = 0; j < 4; j++) {
			sum += data[0][j][i];
		}
		if(sum != sums[1][i + 1])
			return 0;
	}

	// Diagonal
	sum = data[0][0][0] + data[0][1][1] + data[0][2][2] + data[0][3][3];
	if(sum != sums[0][4])
		return 0;
	sum = data[0][0][3] + data[0][1][2] + data[0][2][1] + data[0][3][0];
	if(sum != sums[1][0])
		return 0;
	return 1;
}

int given(int index, int data[][4][4], int sums[][5]) {
	// Check X
	if((data[1][0][y(index)] + data[1][1][y(index)] + 
		data[1][2][y(index)] + data[1][3][y(index)])
		== 3) {
		return (sums[1][y(index) + 1] - (data[0][x(index + 1)][y(index)] + data[0][x(index + 2)][y(index)] + 
		data[0][x(index + 3)][y(index)]));
	}

	// Check Y
	if((data[1][x(index)][0] + data[1][x(index)][1] + 
		data[1][x(index)][2] + data[1][x(index)][3])
		== 3)
		return (sums[0][x(index)] - (data[0][x(index)][(y(index) + 1) % 4] + data[0][x(index)][(y(index) + 2) % 4] + 
		data[0][x(index)][(y(index) + 3) % 4]));	

	// Diagonal
	if(x(index) == y(index))
		if((data[1][0][0] + data[1][1][1] + 
			data[1][2][2] + data[1][3][3]) == 3)
			return (sums[0][4] - (data[0][0][0] + data[0][1][1] + 
			data[0][2][2] + data[0][3][3]) - data[0][x(index)][y(index)]);
	else if((x(index) + y(index)) == 3)
		if((data[1][3][0] + data[1][2][1] + 
			data[1][1][2] + data[1][0][3]) == 3)
			return (sums[0][4] - (data[0][3][0] + data[0][2][1] + 
			data[0][1][2] + data[0][0][3]) - data[0][x(index)][y(index)]);	
	return 0;
}

int smallest(int index, int data[][4][4], int sums[][5]) {
	int small = 1, tmpSmall, i;
	// X
	tmpSmall = sums[1][y(index) + 1];
	for(i = 0; i < 4; i++)
		if(data[1][i][y(index)])
			tmpSmall -= data[0][i][y(index)];
		else
			tmpSmall -= 9;
	small = max(small, (tmpSmall + 9));

	// Y
	tmpSmall = sums[0][x(index)];
	for(i = 0; i < 4; i++)
		if(data[1][x(index)][i])
			tmpSmall -= data[0][x(index)][i];
		else
			tmpSmall -= 9;
	small = max(small, (tmpSmall + 9));
	return small;
}

int biggest(int index, int data[][4][4], int sums[][5]) {
	int big = 9, tmpBig, i;
	// X
	tmpBig = sums[1][y(index) + 1];
	for(i = 0; i < 4; i++)
		if(data[1][i][y(index)])
			tmpBig -= data[0][i][y(index)];
		else
			tmpBig -= 1;
	big = min(big, tmpBig + 1);

	// Y
	tmpBig = sums[0][x(index)];
	for(i = 0; i < 4; i++)
		if(data[1][x(index)][i])
			tmpBig -= data[0][x(index)][i];
		else
			tmpBig -= 1;
	big = min(big, tmpBig + 1);
	return big;
}

int loop(int index, int data[][4][4], int sums[][5]) {
	int maxV, minV, i;

	// All cells filled. Check if this pattern works.
	if(index == 16)
		return works(data, sums);

	// If value set during setup, go to next cell
	if(data[1][x(index)][y(index)])
		return loop(index + 1, data, sums);

	// If can solve value, set it, and go on
	if(data[0][x(index)][y(index)] = given(index, data, sums)) {
		data[1][x(index)][y(index)] = 1;
		data[1][x(index)][y(index)] = loop(index + 1, data, sums);
		if(data[1][x(index)][y(index)] > 0 && data[1][x(index)][y(index)] < 10)
			return 1;
		else
			return 0;
	}


	// Find highest & lowest possible values for this cell.
	minV = smallest(index, data, sums);
	maxV = biggest(index, data, sums);
	// Set cell value flag to true
	data[1][x(index)][y(index)] = 1;
	// Cycle through all values for this cell. Find a working value.
	for(i = minV; i <= maxV; i++) {
		data[0][x(index)][y(index)] = i;
		if(loop(index + 1, data, sums))
			return 1;
	}
	//printData(data);
	// Set the cell to unvisited for the next iteration on a higher level
	data[1][x(index)][y(index)] = 0;
	return 0;
}

void getData(int data[][4][4], int sums[][5]) {
	int i, j, in;
#if verbose
	printf("Enter the 5 values accross the bottom (seperated by newlines) (left to right)\n");
#endif
	for(i = 0; i < 5; i++)
		scanf("%d", &sums[0][i]);
#if verbose
	printf("Enter the 5 values accross the side (top down)\n");
#endif
	for(i = 0; i < 5; i++)
		scanf("%d", &sums[1][i]);
#if verbose
	for(i = 0; i < 5; i++)
		printf("x, x, x, x [%d]\n", sums[1][i]);
	for(i = 0; i < 5; i++)
		printf("[%d], ", sums[0][i]);
	printf("\nEnter the values in the grid, 0 for unknown (Z)\n");
#endif
	for(i = 0; i < 4; i++)
		for(j = 0; j < 4; j++) {
			scanf("%d", &in);
			if(in) {
				data[0][j][i] = in;
				data[1][j][i] = 1;
			}
		}
#if verbose
	printData(data);
	printf("Solving...\n");
#endif
	return;
}

int main(void) {
	// The 4x4 grid. Bottom layer holds flags for values set by puzzle
	int data[2][4][4];
	// The sums you need to make
	int sums[2][5]; // = {{ 29, 13, 15, 23, 19}, {18, 11, 28, 11, 30}};
	int i, j;
	
	for(i = 0; i < 4; i++)
		for(j = 0; j < 4; j++) {
			data[0][i][j] = 1;
			data[1][i][j] = 0;
		}
/*
	data[0][3][0] = 2;
	data[1][3][0] = 1;
	data[0][1][1] = 3;
	data[1][1][1] = 1;
	data[0][0][2] = 6;
	data[1][0][2] = 1;
	data[0][2][3] = 6;
	data[1][2][3] = 1;
*/
	getData(data, sums);
	
	if(loop(0, data, sums))
		printData(data);
	system("pause");
#if verbose
#endif
	return 0;
}

// bcc32 -If:\utils\BCC55\Include -Lf:\utils\BCC55\lib Challenger.c